VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cSysMetrics"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'----------------------------------------------------------------------------------------
'
'   Class Module    : cSysMetrics
'   Description     : System Metrics functions
'   Author          : C. Eswar Santhosh
'   Last Updated    : 17/02/2000
'
'   Copyright Info  :
'
'   This Class module is provided AS-IS. This Class module can be used as a part of a compiled
'   executable whether freeware or not. This Class module may not be posted to any web site
'   or BBS or any redistributable media like CD-ROM without the consent of the author.
'
'   Web Site : http://eswar_santhosh.tripod.com/
'
'   e-mail   : eswar_santhosh@yahoo.com
'
'   Comments :
'
'
'   Revision History :
'
'---------------------------------------------------------------------------------------------

Option Explicit

'
' API Constants (arranged by value)
'
Private Const SM_CXSCREEN As Long = 0
Private Const SM_CYSCREEN As Long = 1

Private Const SM_CXVSCROLL As Long = 2
Private Const SM_CYHSCROLL As Long = 3

Private Const SM_CYCAPTION As Long = 4

Private Const SM_CXBORDER As Long = 5
Private Const SM_CYBORDER As Long = 6

Private Const SM_CXDLGFRAME As Long = 7
Private Const SM_CYDLGFRAME As Long = 8

Private Const SM_CYVTHUMB As Long = 9
Private Const SM_CXHTHUMB As Long = 10

Private Const SM_CXICON As Long = 11
Private Const SM_CYICON As Long = 12

Private Const SM_CXCURSOR As Long = 13
Private Const SM_CYCURSOR As Long = 14

Private Const SM_CYMENU As Long = 15

Private Const SM_CXFULLSCREEN As Long = 16
Private Const SM_CYFULLSCREEN As Long = 17

Private Const SM_CYKANJIWINDOW As Long = 18

Private Const SM_MOUSEPRESENT As Long = 19

Private Const SM_CYVSCROLL As Long = 20
Private Const SM_CXHSCROLL As Long = 21

Private Const SM_DEBUG As Long = 22

Private Const SM_SWAPBUTTON As Long = 23

Private Const SM_RESERVED1 As Long = 24
Private Const SM_RESERVED2 As Long = 25
Private Const SM_RESERVED3 As Long = 26
Private Const SM_RESERVED4 As Long = 27

Private Const SM_CXMIN As Long = 28
Private Const SM_CYMIN As Long = 29

Private Const SM_CXSIZE As Long = 30
Private Const SM_CYSIZE As Long = 31

Private Const SM_CXFRAME As Long = 32
Private Const SM_CYFRAME As Long = 33

Private Const SM_CXMINTRACK As Long = 34
Private Const SM_CYMINTRACK As Long = 35

Private Const SM_CXDOUBLECLK As Long = 36
Private Const SM_CYDOUBLECLK As Long = 37

Private Const SM_CXICONSPACING As Long = 38
Private Const SM_CYICONSPACING As Long = 39

Private Const SM_MENUDROPALIGNMENT As Long = 40

Private Const SM_PENWINDOWS As Long = 41

Private Const SM_DBCSENABLED As Long = 42

Private Const SM_CMOUSEBUTTONS As Long = 43

' #if(WINVER >= 0x0400) Alternative Names
Private Const SM_CXFIXEDFRAME As Long = SM_CXDLGFRAME
Private Const SM_CYFIXEDFRAME As Long = SM_CYDLGFRAME

Private Const SM_CXSIZEFRAME As Long = SM_CXFRAME
Private Const SM_CYSIZEFRAME As Long = SM_CYFRAME

Private Const SM_SECURE As Long = 44

Private Const SM_CXEDGE As Long = 45
Private Const SM_CYEDGE As Long = 46

Private Const SM_CXMINSPACING As Long = 47
Private Const SM_CYMINSPACING As Long = 48

Private Const SM_CXSMICON As Long = 49
Private Const SM_CYSMICON As Long = 50

Private Const SM_CYSMCAPTION As Long = 51

Private Const SM_CXSMSIZE As Long = 52
Private Const SM_CYSMSIZE As Long = 53

Private Const SM_CXMENUSIZE As Long = 54
Private Const SM_CYMENUSIZE As Long = 55

Private Const SM_ARRANGE As Long = 56

Private Const SM_CXMINIMIZED As Long = 57
Private Const SM_CYMINIMIZED As Long = 58

Private Const SM_CXMAXTRACK As Long = 59
Private Const SM_CYMAXTRACK As Long = 60

Private Const SM_CXMAXIMIZED As Long = 61
Private Const SM_CYMAXIMIZED As Long = 62

Private Const SM_NETWORK As Long = 63

Private Const SM_CLEANBOOT As Long = 67

Private Const SM_CXDRAG As Long = 68
Private Const SM_CYDRAG As Long = 69

' #endif /* WINVER >= 0x0400 */

Private Const SM_SHOWSOUNDS As Long = 70

' #if(WINVER >= 0x0400)
Private Const SM_CXMENUCHECK As Long = 71           ' Use instead of GetMenuCheckMarkDimensions()!
Private Const SM_CYMENUCHECK As Long = 72

Private Const SM_SLOWMACHINE As Long = 73

Private Const SM_MIDEASTENABLED As Long = 74
' #endif /* WINVER >= 0x0400 */

' #if (WINVER >= 0x0500) || (_WIN32_WINNT >= 0x0400)
Private Const SM_MOUSEWHEELPRESENT As Long = 75
' #End If

' #if(WINVER >= 0x0500)
Private Const SM_XVIRTUALSCREEN As Long = 76
Private Const SM_YVIRTUALSCREEN As Long = 77

Private Const SM_CXVIRTUALSCREEN As Long = 78
Private Const SM_CYVIRTUALSCREEN As Long = 79

Private Const SM_CMONITORS As Long = 80

Private Const SM_SAMEDISPLAYFORMAT As Long = 81

' #endif /* WINVER >= 0x0500 */

' #if(_WIN32_WINNT >= 0x0500)
Private Const SM_IMMENABLED As Long = 82
' #endif /* _WIN32_WINNT >= 0x0500 */

Private Const SM_CMETRICSNT As Long = 76         ' SM_CMETRICS value for Win NT

Private Const SM_CMETRICS2K As Long = 83         ' SM_CMETRICS value for Win2K


' #if(WINVER >= 0x0500)
Private Const SM_REMOTESESSION As Long = &H1000
' #endif /* WINVER >= 0x0500 */

' Arrange Constants
Private Const ARW_BOTTOMLEFT As Long = &H0
Private Const ARW_BOTTOMRIGHT As Long = &H1
Private Const ARW_TOPLEFT As Long = &H2
Private Const ARW_TOPRIGHT As Long = &H3
Private Const ARW_STARTMASK As Long = &H3
Private Const ARW_STARTRIGHT As Long = &H1
Private Const ARW_STARTTOP As Long = &H2

Private Const ARW_LEFT As Long = &H0
Private Const ARW_RIGHT As Long = &H0
Private Const ARW_UP As Long = &H4
Private Const ARW_DOWN As Long = &H4
Private Const ARW_HIDE As Long = &H8

'
' API Declarations
'
Private Declare Function GetSystemMetrics Lib "user32" _
(ByVal nIndex As Long) As Long


'
' Enums
'
Public Enum eBootMode
    bootNormal = 0
    bootSafe = 1
    bootSafeNetwork = 2
End Enum

' Arrange Constants
Public Enum eArrangeStart
    easBottomRight = ARW_BOTTOMRIGHT
    easBottomLeft = ARW_BOTTOMLEFT
    easTopRight = ARW_TOPRIGHT
    easTopLeft = ARW_TOPLEFT
    easHide = ARW_HIDE
End Enum

Public Enum eArrangeDirection
    eadLeft = ARW_LEFT
    eadRight = ARW_RIGHT
    eadUp = ARW_UP
    eadDown = ARW_DOWN
End Enum

Public Enum eVirtualScreenMetric
    vLeft
    vTop
    vWidth
    vHeight
End Enum

Public Enum eScrollBarMetric
    HorizontalWidth
    HorizontalHeight
    VerticalWidth
    VerticalHeight
    HorizontalThumbWidth
    VerticalThumbHeight
End Enum

Public Enum eIconMetric
    IconWidth
    IconHeight
    IconSpacingWidth
    IconSpacingHeight
    CursorWidth
    CursorHeight
    SmallIconWidth
    SmallIconHeight
End Enum

Public Enum eBorderMetric
    BorderWidth
    BorderHeight
    Border3DWidth
    Border3DHeight
    FixedDialogFrameWidth
    FixedDialogFrameHeight
    SizableWindowFrameWidth
    SizableWindowFrameHeight
End Enum

' The second-click of a double-click must occur within the rectangluar area
' bounding the first click location to be considered as a Double-Click.
' The mouse button can be released within the rectangular area within the
' starting point of dragging operation to cancel the action.

Public Enum eRectMetric
 DoubleClickWidth
 DoubleClickHeight
 DragAreaWidth
 DragAreaHeight
End Enum

Public Enum eWindowMetric
    FullScreenClientWidth
    FullScreenClientHeight
    MinimumWidth
    MinimumHeight
    MinimumSizableWidth
    MinimumSizableHeight
    MaximumSizableWidth
    MaximumSizableHeight
    DefaultMaximizedWidth
    DefaultMaximizedHeight
    DefaultMinimizedWidth
    DefaultMinimizedHeight
    MinimizedWindowGridWidth
    MinimizedWindowGridHeight
End Enum

Public Enum eNCMetric
    MenuCheckMarkWidth
    MenuCheckMarkHeight
    MenuBarHeight
    MenuBarButtonWidth      ' Such as Close Button of a MDI Child form
    MenuBarButtonHeight
    TitlebarHeight
    TitleBarButtonWidth
    TitleBarButtonHeight
    SmallCaptionHeight
    SmallCaptionButtonWidth
    SmallCaptionButtonHeight
End Enum
'
' Local Variables
'
Private Const eAppName As String = ".System Metrics Class"

' I found it cumbersome to add this error code to Each and every property.
' This error is raised whenever the GetSystemMetrics function returns 0 except in cases
' where zero is an acceptable value. If you want proper error trapping, go ahead and do
' it yourself.
Private Const errAPI As Long = 29000
Private Const sErrAPI As String = "Unable to obtain the requested information from the System."

Private Const errNA As Long = 29001
Private Const sErrNA As String = "This functionality is not supported by the Operating System."

Dim retval As Long      ' Return Value of the API function
Dim mOS As OSInfo       ' OS Information is required for checking
Dim InTwips As Boolean  ' Return Value in Twips ?

Public Property Get ReturnUnits(ByVal UseTwips As Boolean)
    InTwips = UseTwips
End Property

Public Property Get ArrangementStart() As eArrangeStart
Attribute ArrangementStart.VB_Description = "Returns the position at which the System starts to arrange Minimized Windows"

Dim retval As Long
retval = GetSystemMetrics(SM_ARRANGE)

If retval And easBottomLeft Then
    ArrangementStart = easBottomLeft
ElseIf retval And easBottomRight Then
    ArrangementStart = easBottomRight
ElseIf retval And easTopLeft Then
    ArrangementStart = easTopLeft
ElseIf retval And easTopRight Then
    ArrangementStart = easTopRight
ElseIf retval And easHide Then
    ArrangementStart = easHide
End If
End Property

Public Property Get ArrangementDirection() As eArrangeDirection
Attribute ArrangementDirection.VB_Description = "Returns the Direction in which the System arranges the minimized Windows"

Dim retval As Long
retval = GetSystemMetrics(SM_ARRANGE)

If retval And eadLeft Then
    ArrangementDirection = eadLeft
ElseIf retval And eadRight Then
    ArrangementDirection = eadRight
ElseIf retval And eadUp Then
    ArrangementDirection = eadUp
ElseIf retval And eadDown Then
    ArrangementDirection = eadDown
End If
End Property

Public Property Get BootMode() As eBootMode
Attribute BootMode.VB_Description = "Returns the Booting Mode"
'
' Get the Booting Mode
'
BootMode = GetSystemMetrics(SM_CLEANBOOT)
End Property

Public Property Get DBCSEnabled() As Boolean
Attribute DBCSEnabled.VB_Description = "True if a Double Byte Character Supporting version of User.exe is installed"
    DBCSEnabled = (GetSystemMetrics(SM_DBCSENABLED) <> 0)
End Property

Public Property Get DebugVersion() As Boolean
Attribute DebugVersion.VB_Description = "True if Debug version of User.exe is installed."
    DebugVersion = (GetSystemMetrics(SM_DEBUG) <> 0)
End Property

Public Property Get IMMEnabled() As Boolean
Attribute IMMEnabled.VB_Description = "Returns True if Input Method Manager or Input Method Editor features are Enabled in Win2K or later Systems."
' Win2K only
If mOS.IsWin2K Then
    IMMEnabled = (GetSystemMetrics(SM_IMMENABLED) <> 0)
Else
    Err.Raise errNA, sErrNA, App.Title & eAppName
End If
End Property

Public Property Get MenuDropAlignRight() As Boolean
Attribute MenuDropAlignRight.VB_Description = "True if the Drop down menus (Popup menus) are right-aligned with their parent menus."
    MenuDropAlignRight = (GetSystemMetrics(SM_MENUDROPALIGNMENT) <> 0)
End Property

Public Property Get MidEastSupport() As Boolean
Attribute MidEastSupport.VB_Description = "True if the System supports Arablic or Hebrew Lanuages"
    MidEastSupport = (GetSystemMetrics(SM_MIDEASTENABLED) <> 0)
End Property

Public Property Get MonitorsCount() As Long
Attribute MonitorsCount.VB_Description = "No. Of Monitors installed (Win98, Win2K or later)"
' Win98 or Win2K only
If mOS.IsWin98 Or mOS.IsWin2K Then
    MonitorsCount = GetSystemMetrics(SM_CMONITORS)
Else
    Err.Raise errNA, sErrNA, App.Title & eAppName
End If
End Property

Public Property Get MouseButtons() As Long
Attribute MouseButtons.VB_Description = "No. Of Mouse Buttons, Zero if Mouse is not installed."
    ' Here return value of zero indicates that no mouse is installed
    MouseButtons = GetSystemMetrics(SM_CMOUSEBUTTONS)
End Property

Public Property Get MouseInstalled() As Boolean
Attribute MouseInstalled.VB_Description = "True if Mouse is installed"
    MouseInstalled = (GetSystemMetrics(SM_MOUSEPRESENT) <> 0)
End Property

Public Property Get MouseWheelPresent() As Boolean
Attribute MouseWheelPresent.VB_Description = "True if Mouse Wheel is present (Windows NT 4.0 or later and Windows 98 or later)"
' WinNT 4.0+ and Win98
If (mOS.IsNT() And mOS.OSMajorVersion >= 4) Or mOS.IsWin98 Then
    MouseWheelPresent = (GetSystemMetrics(SM_MOUSEWHEELPRESENT) <> 0)
Else
    Err.Raise errNA, sErrNA, App.Title & eAppName
End If
End Property

Public Property Get NetworkPresent() As Boolean
Attribute NetworkPresent.VB_Description = "Returns True if Network is Present"
' The Least Significant bit is set if Network is installed
Dim retval As Long
retval = GetSystemMetrics(SM_NETWORK)
NetworkPresent = (retval Mod 2 = 1)
End Property

Public Property Get PenSupport() As Boolean
Attribute PenSupport.VB_Description = "True if Windows Pen Computing Extensions are installed"
PenSupport = (GetSystemMetrics(SM_PENWINDOWS) <> 0)
End Property

Public Property Get SameColorFormat() As Boolean
Attribute SameColorFormat.VB_Description = "Returns True if in a Multiple monitors connected system, all the display monitors have the same color format (Win98 or later and Win2K or later)"
If mOS.IsWin2K Or mOS.IsWin98 Then
    SameColorFormat = (GetSystemMetrics(SM_SAMEDISPLAYFORMAT) <> 0)
Else
    Err.Raise errNA, sErrNA, App.Title & eAppName
End If
End Property

Public Property Get Secure() As Boolean
Attribute Secure.VB_Description = "Returns True if the Security is present"
Secure = (GetSystemMetrics(SM_SECURE) <> 0)
End Property

Public Property Get ShowSounds() As Boolean
Attribute ShowSounds.VB_Description = "Returns True if the User has enabled Show Sounds Option in Accessibility Features"
ShowSounds = (GetSystemMetrics(SM_SHOWSOUNDS) <> 0)
End Property

Public Property Get SlowMachine() As Boolean
Attribute SlowMachine.VB_Description = "True if the System has a Slow Processor"
SlowMachine = (GetSystemMetrics(SM_SLOWMACHINE) <> 0)
End Property

Public Property Get SwapButtons() As Boolean
Attribute SwapButtons.VB_Description = "True if the meanings of the left and right mouse buttons are swapped"
SwapButtons = (GetSystemMetrics(SM_SWAPBUTTON) <> 0)
End Property

Public Property Get TerminalServicesClientSession() As Boolean
Attribute TerminalServicesClientSession.VB_Description = "Returns True if the Application is part ofa Terminal Services Client Session. False if it is running with a Terminal Services Console Session."
' Supported by Windows NT 4.0 SP4 and later. I don't know if this code will work under NT 4 SP4.
Dim SPInfo As String

If mOS.IsWin2K Then
    TerminalServicesClientSession = (GetSystemMetrics(SM_REMOTESESSION) <> 0)
ElseIf mOS.IsNT And mOS.OSMajorVersion >= 4 Then
     SPInfo = Replace(mOS.PSSInfo, "Service Pack", "", , , vbTextCompare)
     If Val(SPInfo) >= 4 Then
        TerminalServicesClientSession = (GetSystemMetrics(SM_REMOTESESSION) <> 0)
     Else
        Err.Raise errNA, sErrNA, App.Title & eAppName
     End If
Else
    Err.Raise errNA, sErrNA, App.Title & eAppName
End If
End Property

Public Property Get KanjiWindowHeight() As Long
Attribute KanjiWindowHeight.VB_Description = "Height of the Kanji Window in DBCS systems"
    KanjiWindowHeight = GetSystemMetrics(SM_CYKANJIWINDOW)
    If InTwips Then KanjiWindowHeight = KanjiWindowHeight * Screen.TwipsPerPixelY
End Property

'
' The Following are SM_CX* and SM_CY* properties that return value in Twips (except IconMetrics which returns Pixel Values)
'
Public Property Get ScreenWidth() As Long
Attribute ScreenWidth.VB_Description = "Width of the Primary Display Monitor"
    ScreenWidth = GetSystemMetrics(SM_CXSCREEN)
    If InTwips Then ScreenWidth = ScreenWidth * Screen.TwipsPerPixelX
End Property

Public Property Get ScreenHeight() As Long
Attribute ScreenHeight.VB_Description = "Height of the Primary Display Monitor"
    ScreenHeight = GetSystemMetrics(SM_CYSCREEN)
    If InTwips Then ScreenHeight = ScreenHeight * Screen.TwipsPerPixelY
End Property

Public Function BorderSize(ByVal reqSize As eBorderMetric)

Select Case reqSize
Case BorderWidth
    BorderSize = GetSystemMetrics(SM_CXBORDER)
    
Case BorderHeight
    BorderSize = GetSystemMetrics(SM_CYBORDER)
    
Case Border3DWidth
    BorderSize = GetSystemMetrics(SM_CXEDGE)
    
Case Border3DHeight
    BorderSize = GetSystemMetrics(SM_CYEDGE)
    
Case FixedDialogFrameWidth
    BorderSize = GetSystemMetrics(SM_CXFIXEDFRAME)
        
Case FixedDialogFrameHeight
    BorderSize = GetSystemMetrics(SM_CYFIXEDFRAME)
    
Case SizableWindowFrameWidth
    BorderSize = GetSystemMetrics(SM_CXSIZEFRAME)
    
Case SizableWindowFrameHeight
    BorderSize = GetSystemMetrics(SM_CYSIZEFRAME)
    
End Select

If InTwips Then
    Select Case reqSize
    Case Border3DWidth, BorderWidth, FixedDialogFrameWidth, SizableWindowFrameWidth
        BorderSize = BorderSize * Screen.TwipsPerPixelX
    Case Else
        BorderSize = BorderSize * Screen.TwipsPerPixelY
    End Select
End If
End Function

Public Function IconSize(ByVal reqSize As eIconMetric) As Long
'
' Returns Value in Pixels
'
Select Case reqSize
Case IconWidth
    IconSize = GetSystemMetrics(SM_CXICON)
    
Case IconHeight
    IconSize = GetSystemMetrics(SM_CYICON)
    
Case SmallIconWidth
    IconSize = GetSystemMetrics(SM_CXSMICON)
    
Case SmallIconHeight
    IconSize = GetSystemMetrics(SM_CYSMICON)
    
Case IconSpacingWidth
    IconSize = GetSystemMetrics(SM_CXICONSPACING)
    
Case IconSpacingHeight
    IconSize = GetSystemMetrics(SM_CYICONSPACING)
    
Case CursorWidth
    IconSize = GetSystemMetrics(SM_CXCURSOR)
    
Case CursorHeight
    IconSize = GetSystemMetrics(SM_CXCURSOR)
    
End Select

If InTwips Then
    Select Case reqSize
    Case IconWidth, IconSpacingWidth, SmallIconWidth, CursorWidth
        IconSize = IconSize * Screen.TwipsPerPixelX
        
    Case Else
        IconSize = IconSize * Screen.TwipsPerPixelY
    End Select
End If
End Function

Public Function NonClientSize(ByVal reqSize As eNCMetric) As Long

Select Case reqSize
Case MenuCheckMarkWidth
    NonClientSize = GetSystemMetrics(SM_CXMENUCHECK)
    
Case MenuCheckMarkHeight
    NonClientSize = GetSystemMetrics(SM_CYMENUCHECK)
    
Case MenuBarHeight
    NonClientSize = GetSystemMetrics(SM_CYMENU)
    
Case MenuBarButtonWidth
    NonClientSize = GetSystemMetrics(SM_CXMENUSIZE)
    
Case MenuBarButtonHeight
    NonClientSize = GetSystemMetrics(SM_CYMENUSIZE)
    
Case TitlebarHeight
    NonClientSize = GetSystemMetrics(SM_CYCAPTION)
    
Case TitleBarButtonWidth
    NonClientSize = GetSystemMetrics(SM_CXSIZE)
    
Case TitleBarButtonHeight
    NonClientSize = GetSystemMetrics(SM_CYSIZE)
    
Case SmallCaptionHeight
    NonClientSize = GetSystemMetrics(SM_CYSMCAPTION)
    
Case SmallCaptionButtonWidth
    NonClientSize = GetSystemMetrics(SM_CXSMSIZE)
    
Case SmallCaptionButtonHeight
    NonClientSize = GetSystemMetrics(SM_CYSMSIZE)
    
End Select

If InTwips Then
    Select Case reqSize
    Case MenuCheckMarkWidth, MenuBarButtonWidth, TitleBarButtonWidth, SmallCaptionButtonWidth
        NonClientSize = NonClientSize * Screen.TwipsPerPixelX
    Case Else
        NonClientSize = NonClientSize * Screen.TwipsPerPixelY
    End Select
End If

End Function

Public Function RectSize(ByVal reqSize As eRectMetric) As Long

Select Case reqSize
Case DoubleClickWidth
    RectSize = GetSystemMetrics(SM_CXDOUBLECLK)
    
Case DoubleClickHeight
    RectSize = GetSystemMetrics(SM_CYDOUBLECLK)
    
Case DragAreaWidth
    RectSize = GetSystemMetrics(SM_CXDRAG)
    
Case DragAreaHeight
    RectSize = GetSystemMetrics(SM_CYDRAG)
End Select

If InTwips Then
    Select Case reqSize
    Case DoubleClickWidth, DragAreaWidth
        RectSize = RectSize * Screen.TwipsPerPixelX
        
    Case Else
        RectSize = RectSize * Screen.TwipsPerPixelY
    End Select
End If
End Function

Public Function ScrollBarSize(ByVal reqSize As eScrollBarMetric) As Long

Select Case reqSize
Case HorizontalWidth
    ScrollBarSize = GetSystemMetrics(SM_CXHSCROLL)
    
Case HorizontalHeight
    ScrollBarSize = GetSystemMetrics(SM_CYHSCROLL)
    
Case HorizontalThumbWidth
    ScrollBarSize = GetSystemMetrics(SM_CXHTHUMB)
    
Case VerticalWidth
    ScrollBarSize = GetSystemMetrics(SM_CXVSCROLL)
    
Case VerticalHeight
    ScrollBarSize = GetSystemMetrics(SM_CYVSCROLL)
    
Case VerticalThumbHeight
    ScrollBarSize = GetSystemMetrics(SM_CYVTHUMB)
End Select

If InTwips Then
    Select Case reqSize
    Case HorizontalWidth, VerticalWidth, HorizontalThumbWidth
        ScrollBarSize = ScrollBarSize * Screen.TwipsPerPixelX
        
    Case Else
        ScrollBarSize = ScrollBarSize * Screen.TwipsPerPixelY
    End Select
End If
End Function

Public Function VirtualScreenSize(ByVal reqSize As eVirtualScreenMetric) As Long
Attribute VirtualScreenSize.VB_Description = "Returns the requested Virtual Screen quantity"

If mOS.IsWin2K Or mOS.IsWin98 Then
    Select Case reqSize
    Case vLeft
        VirtualScreenSize = GetSystemMetrics(SM_XVIRTUALSCREEN)
        
    Case vTop
        VirtualScreenSize = GetSystemMetrics(SM_YVIRTUALSCREEN)
        
    Case vWidth
        VirtualScreenSize = GetSystemMetrics(SM_CXVIRTUALSCREEN)
        
    Case vHeight
        VirtualScreenSize = GetSystemMetrics(SM_CYVIRTUALSCREEN)
        
    End Select
    
    If InTwips Then
        Select Case reqSize
        Case vLeft, vWidth
            VirtualScreenSize = VirtualScreenSize * Screen.TwipsPerPixelX
            
        Case Else
            VirtualScreenSize = VirtualScreenSize * Screen.TwipsPerPixelY
        End Select
    End If
Else
    Err.Raise errNA, sErrNA, App.Title & eAppName
End If
End Function

Public Function WindowSize(ByVal reqSize As eWindowMetric) As Long

Select Case reqSize
Case FullScreenClientWidth
    WindowSize = GetSystemMetrics(SM_CXFULLSCREEN)
    
Case FullScreenClientHeight
    WindowSize = GetSystemMetrics(SM_CYFULLSCREEN)
    
Case DefaultMaximizedWidth
    WindowSize = GetSystemMetrics(SM_CXMAXIMIZED)
    
Case DefaultMaximizedHeight
    WindowSize = GetSystemMetrics(SM_CYMAXIMIZED)
    
Case DefaultMinimizedWidth
    WindowSize = GetSystemMetrics(SM_CXMINIMIZED)
    
Case DefaultMinimizedHeight
    WindowSize = GetSystemMetrics(SM_CYMINIMIZED)
    
Case MaximumSizableWidth
    WindowSize = GetSystemMetrics(SM_CXMAXTRACK)
    
Case MaximumSizableHeight
    WindowSize = GetSystemMetrics(SM_CYMAXTRACK)
    
Case MinimumSizableWidth
    WindowSize = GetSystemMetrics(SM_CXMINTRACK)
    
Case MinimumSizableHeight
    WindowSize = GetSystemMetrics(SM_CYMINTRACK)
    
Case MinimumWidth
    WindowSize = GetSystemMetrics(SM_CXMIN)
    
Case MinimumHeight
    WindowSize = GetSystemMetrics(SM_CYMIN)
    
Case MinimizedWindowGridWidth
    WindowSize = GetSystemMetrics(SM_CXMINSPACING)
    
Case MinimizedWindowGridHeight
    WindowSize = GetSystemMetrics(SM_CYMINSPACING)
End Select

If InTwips Then
    Select Case reqSize
    Case FullScreenClientWidth, DefaultMaximizedWidth, DefaultMinimizedWidth, _
    MaximumSizableWidth, MinimizedWindowGridWidth, MinimumSizableWidth, MinimumWidth
        
        WindowSize = WindowSize * Screen.TwipsPerPixelX
        
    Case Else
        WindowSize = WindowSize * Screen.TwipsPerPixelY
    End Select
End If
End Function

'
' Class Functions
'
Private Sub Class_Initialize()
'
' Get OS Information
'
    Set mOS = New OSInfo
End Sub

Private Sub Class_Terminate()
    ' Not required. Just for practice of good but extremely inefficient Code practice.
    Set mOS = Nothing
End Sub
